=== debian/changelog ===
mayo (0.9.0+ds-2build1) resolute; urgency=medium

  * Rebuild against latest assimp

 -- Jeremy Bícha <jbicha@ubuntu.com>  Wed, 29 Oct 2025 09:43:34 -0400

mayo (0.9.0+ds-2) unstable; urgency=medium

  * Apply patch: src/3rdparty/fast_float/float_common.h:
    Add loongarch64 support. (Closes: #1103407)
    Thanks Dandan Zhang.
  * d/copyright: short license formatting fixed.

 -- Alex Myczko <tar@debian.org>  Thu, 17 Apr 2025 10:40:45 +0000

mayo (0.9.0+ds-1) unstable; urgency=medium

  * New upstream version.

 -- Alex Myczko <tar@debian.org>  Thu, 13 Feb 2025 14:30:24 +0000

mayo (0.8.0+git20240722+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #1076736)

 -- Alex Myczko <tar@debian.org>  Mon, 22 Jul 2024 19:23:09 +0000
