=== debian/control ===
Source: mayo
Section: science
Priority: optional
Maintainer: Alex Myczko <tar@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 qtbase5-dev,
 libqt5svg5-dev,
 libocct-data-exchange-dev,
 libocct-draw-dev,
 occt-misc,
 libtbb-dev,
 libxi-dev,
 libassimp-dev,
Standards-Version: 4.7.0
Homepage: https://github.com/fougue/mayo
Vcs-Browser: https://salsa.debian.org/debian/mayo
Vcs-Git: https://salsa.debian.org/debian/mayo.git

Package: mayo
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: 3D CAD viewer and converter based on Qt + OpenCascade
 This is an open-source 3D CAD viewer and converter based on Open CASCADE
 Technology and Qt.
 .
 Users can view and convert 3D CAD files in different formats (STEP, IGES,
 mesh formats). Mayo helps also user to graphically explore/analyze assembly
 trees and view properties (e.g. area, volume).
 .
 Typical end-users are people working in design/manufacturing industry, either
 to use the software as is or customized through source code.
