## mayo 0.9.0+git20251225+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 cmake_minimum_required(VERSION 3.10)
 
 set(Mayo_VersionMajor 0)
-set(Mayo_VersionMinor 9)
+set(Mayo_VersionMinor 10)
 set(Mayo_VersionPatch 0)
 set(Mayo_Version ${Mayo_VersionMajor}.${Mayo_VersionMinor}.${Mayo_VersionPatch})
 
@@ -83,7 +83,6 @@
     )
 endif()
 
-# TODO Make option Mayo_BuildTests dependent of Mayo_BuildApp)
 option(Mayo_BuildApp "Build Mayo GUI application" ON)
 option(Mayo_BuildConvCli "Build Mayo CLI converter" ON)
 
@@ -188,6 +187,8 @@
     list(APPEND MayoCore_LinkLibraries Opengl32 User32)
 elseif(APPLE)
     list(APPEND MayoCore_LinkLibraries iconv)
+elseif(HAIKU)
+    list(APPEND MayoCore_LinkLibraries iconv)
 endif()
 
 ##########
@@ -241,21 +242,6 @@
     ${PROJECT_SOURCE_DIR}/src/io_ply/*.h
 )
 
-##########
-# Unit tests
-##########
-
-if(Mayo_BuildTests)
-    file(GLOB MayoTests_HeaderFiles ${PROJECT_SOURCE_DIR}/tests/*.h)
-    file(GLOB MayoTests_SourceFiles ${PROJECT_SOURCE_DIR}/tests/*.cpp)
-
-    set(MAYO_WITH_TESTS 1)
-    list(APPEND MayoTests_LinkLibraries Qt${QT_VERSION_MAJOR}::Test)
-
-    file(GLOB MayoTests_InputFiles ${PROJECT_SOURCE_DIR}/tests/inputs/*.*)
-    file(COPY ${MayoTests_InputFiles} DESTINATION ${CMAKE_BINARY_DIR}/tests/inputs)
-    file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/tests/outputs)
-endif()
 
 ##########
 # OpenCascade
@@ -357,3 +343,15 @@
         list(
             REMOVE_ITEM MayoIO_SourceFiles
             ${PROJECT_SOURCE_DIR}/src/io_occ/io_occ_base_mesh.cpp
+            ${PROJECT_SOURCE_DIR}/src/io_occ/io_occ_gltf_reader.cpp
+            ${PROJECT_SOURCE_DIR}/src/io_occ/io_occ_obj_reader.cpp
+        )
+        message(STATUS "glTF reader disabled because OpenCascade < v7.4")
+        message(STATUS "OBJ reader disabled because OpenCascade < v7.4")
+    endif()
+
+    if(OpenCASCADE_VERSION VERSION_LESS 7.5.0)
+        list(REMOVE_ITEM MayoIO_SourceFiles ${PROJECT_SOURCE_DIR}/src/io_occ/io_occ_gltf_writer.cpp)
+        message(STATUS "glTF writer disabled because OpenCascade < v7.5")
+    endif()
+
