=== debian/changelog ===
mayo (0.9.0+git20251225+ds-2) unstable; urgency=medium

  * Upload to sid. (Closes: #1104187)
  * d/control: bump year.
  * d/mayo.desktop: added.
  * d/watch: updated.

 -- Alex Myczko <tar@debian.org>  Fri, 02 Jan 2026 12:57:04 +0100

mayo (0.9.0+git20251225+ds-1) experimental; urgency=medium

  * New upstream version.
  * d/watch: update to version 5.

 -- Alex Myczko <tar@debian.org>  Thu, 25 Dec 2025 23:03:54 +0000
