=== debian/watch ===
Version: 5

# GitHub hosted projects.
Template: Github
Dversionmangle: s/[+]ds[0-9]?//
Owner: fougue
Project: mayo
Repack: yes
Repacksuffix: +ds
